Overview | Modules | Class Hierarchy | Classes | Members

Public Member Functions | Static Public Member Functions
tlp::GlTextureManager Class Reference

Class to manage textures Singleton class to load/store textures need by OpenGL rendering. More...

`#include <GlTextureManager.h>`

Collaboration diagram for tlp::GlTextureManager:
[legend]

List of all members.

## Public Member Functions

- OpenGlErrorViewer * setErrorViewer (OpenGlErrorViewer *errorViewer)
- void changeContext (unsigned long context)
- void removeContext (unsigned long context)
- GlTexture getTextureInfo (const std::string &)
- bool existsTexture (const std::string &filename)
- bool loadTextureFromRawData (const std::string &textureName, int width, int height, bool hasAlpha, unsigned char *data)
- bool loadTexture (const std::string &)
- void deleteTexture (const std::string &)
- void beginNewTexture (const std::string &)
- bool activateTexture (const std::string &, unsigned int)
- bool activateTexture (const std::string &)
- void desactivateTexture ()
- void setAnimationFrame (unsigned int id)
- unsigned int getAnimationFrame ()
- void clearErrorVector ()
- void removeEntryOfErrorVector (const std::string &name)
- void registerExternalTexture (const std::string &textureName, const GLuint textureId)

## Static Public Member Functions

- static void createInst ()
- static GlTextureManager & getInst ()

## Detailed Description

Class to manage textures Singleton class to load/store textures need by OpenGL rendering.

## Member Function Documentation

bool tlp::GlTextureManager::activateTexture | ( | const std::string & | ,
|  | unsigned | int
| ) |  |

Activate a texture with given name

bool tlp::GlTextureManager::activateTexture | ( | const std::string & |  | ) |

Activate a texture with given name

void tlp::GlTextureManager::beginNewTexture | ( | const std::string & |  | ) |

Begin a new texture with given name

void tlp::GlTextureManager::changeContext | ( | unsigned long | context | ) |

Change the current OpenGl context (each OpenGl window have a different OpenGl context)

void tlp::GlTextureManager::clearErrorVector | ( |  | ) | `[inline]`

Clear vector of textures with error

static void tlp::GlTextureManager::createInst | ( |  | ) | `[static]`

Create the texture manager singleton

void tlp::GlTextureManager::deleteTexture | ( | const std::string & |  | ) |

Remove texture with given name

void tlp::GlTextureManager::desactivateTexture | ( |  | ) |

Disable texture with given name

bool tlp::GlTextureManager::existsTexture | ( | const std::string & | filename | ) |

Check if a texture fo the given name exists in the current context

unsigned int tlp::GlTextureManager::getAnimationFrame | ( |  | ) | `[inline]`

Get animationStep of next textures

static GlTextureManager& tlp::GlTextureManager::getInst | ( |  | ) | `[inline, static]`

Return the texture manager singleton, il singleton doesn't exist this function create it

GlTexture tlp::GlTextureManager::getTextureInfo | ( | const std::string & |  | ) |

Return texture info (id, width and height) for the given name

bool tlp::GlTextureManager::loadTexture | ( | const std::string & |  | ) |

Load texture with given name

bool tlp::GlTextureManager::loadTextureFromRawData | ( | const std::string & | textureName,
|  | int | width,
|  | int | height,
|  | bool | hasAlpha,
|  | unsigned char * | data
| ) |  |

Load texture with textureName from Raw data

void tlp::GlTextureManager::registerExternalTexture | ( | const std::string & | textureName,
|  | const GLuint | textureId
| ) |  |

Register an external texture is GlTextureManager

void tlp::GlTextureManager::removeContext | ( | unsigned long | context | ) |

Remove all textures of an OpenGl context and remove this context

void tlp::GlTextureManager::removeEntryOfErrorVector | ( | const std::string & | name | ) | `[inline]`

Remove an entry of vector of textures with error

void tlp::GlTextureManager::setAnimationFrame | ( | unsigned int | id | ) | `[inline]`

Set animationStep for next textures (for next activateTexture)

OpenGlErrorViewer* tlp::GlTextureManager::setErrorViewer | ( | OpenGlErrorViewer * | errorViewer | ) | `[inline]`

Change the error viewer and return the old one

Tulip Software by LaBRI Visualization Team 2001 - 2012